/*
  cubexcgiin.cpp
  Cubex by Eric Dietz (c) 2003
  Cube Puzzle and Universal Solver, HTML output.
  Notes: readme.txt  Email: root@wrongway.org
  NOTE: This program is unaffiliated with the Rubik's Cube Trademark.
*/

#include <cstdio>
#include <string>
#include <time.h>
using namespace std;
// #include <complex>
// #include <conio>
// #include <dos>
// #include <fcntl>
// #include <fstream>
// #include <io>
// #include <iostream>
// #include <malloc>
// #include <math>
// #include <stdlib>
// #include <process>
#include "cubex.h"

// shared variables...
Cubex thecube;
Cubex thetocube;
string col[7];
string disp_diagrams = "0";
string disp_graphics = "0";
string fixcen = "0";
string solveto = "0";
string fixcol = "0";
string adv = "0";
string sel = "1";
string help = "0";
string cmd = "";
int cmdc;
// output cube position and custom colors for the JavaScript
void JavaDefaults() {
  int n;
  n = 0;
  printf("ourcub = Array(");
  for (int i = -1; i <= 1; i++) {
    for (int j = -1; j <= 1; j++) {
      printf("%i", *thecube.face(j,2,-i));
      n++; if (n < 54) printf(",");
    }
  }
  for (int i = -1; i <= 1; i++) {
    for (int j = -1; j <= 1; j++) {
      printf("%i", *thecube.face(j,-i,-2));
      n++; if (n < 54) printf(",");
    }
  }
  for (int i = -1; i <= 1; i++) {
    for (int j = -1; j <= 1; j++) {
      printf("%i", *thecube.face(-2,-i,-j));
      n++; if (n < 54) printf(",");
    }
  }
  for (int i = -1; i <= 1; i++) {
    for (int j = -1; j <= 1; j++) {
      printf("%i", *thecube.face(-j,-i,2));
      n++; if (n < 54) printf(",");
    }
  }
  for (int i = -1; i <= 1; i++) {
    for (int j = -1; j <= 1; j++) {
      printf("%i", *thecube.face(2,-i,j));
      n++; if (n < 54) printf(",");
    }
  }
  for (int i = -1; i <= 1; i++) {
    for (int j = -1; j <= 1; j++) {
      printf("%i", *thecube.face(j,-2,i));
      n++; if (n < 54) printf(",");
    }
  }
  printf(");\n");
  printf("ourcen = Array(-1");
  printf(",%i",*thecube.face(0,1,0));
  printf(",%i",*thecube.face(0,0,-1));
  printf(",%i",*thecube.face(-1,0,0));
  printf(",%i",*thecube.face(0,0,1));
  printf(",%i",*thecube.face(1,0,0));
  printf(",%i",*thecube.face(0,-1,0));
  printf(");\n");
  n = 0;
  printf("ourtocub = Array(");
  for (int i = -1; i <= 1; i++) {
    for (int j = -1; j <= 1; j++) {
      printf("%i", *thetocube.face(j,2,-i));
      n++; if (n < 54) printf(",");
    }
  }
  for (int i = -1; i <= 1; i++) {
    for (int j = -1; j <= 1; j++) {
      printf("%i", *thetocube.face(j,-i,-2));
      n++; if (n < 54) printf(",");
    }
  }
  for (int i = -1; i <= 1; i++) {
    for (int j = -1; j <= 1; j++) {
      printf("%i", *thetocube.face(-2,-i,-j));
      n++; if (n < 54) printf(",");
    }
  }
  for (int i = -1; i <= 1; i++) {
    for (int j = -1; j <= 1; j++) {
      printf("%i", *thetocube.face(-j,-i,2));
      n++; if (n < 54) printf(",");
    }
  }
  for (int i = -1; i <= 1; i++) {
    for (int j = -1; j <= 1; j++) {
      printf("%i", *thetocube.face(2,-i,j));
      n++; if (n < 54) printf(",");
    }
  }
  for (int i = -1; i <= 1; i++) {
    for (int j = -1; j <= 1; j++) {
      printf("%i", *thetocube.face(j,-2,i));
      n++; if (n < 54) printf(",");
    }
  }
  printf(");\n");
  printf("ourtocen = Array(-1");
  printf(",%i",*thetocube.face(0,1,0));
  printf(",%i",*thetocube.face(0,0,-1));
  printf(",%i",*thetocube.face(-1,0,0));
  printf(",%i",*thetocube.face(0,0,1));
  printf(",%i",*thetocube.face(1,0,0));
  printf(",%i",*thetocube.face(0,-1,0));
  printf(");\n");
  printf("ourcol = Array( \"0\" ");
  for (int i = 1; i <= 6; i++) {
    printf(", \"%s\" ", col[i].c_str());
  }
  printf(");\n");
  printf("disp_diagrams = %s;\n", disp_diagrams.c_str());
  printf("disp_graphics = %s;\n", disp_graphics.c_str());
  printf("fixcen = %s;\n", fixcen.c_str());
  printf("solveto = %s;\n", solveto.c_str());
  printf("fixcol = %s;\n", fixcol.c_str());
  printf("adv = %s;\n", adv.c_str());
  printf("sel = %s;\n", sel.c_str());
  printf("help = %s;\n", help.c_str());
  //printf("ver = \"%s\";\n", Cubex::ver);
}
// read optional command-line paramters, and reset cube
void CommandDefaults() {
  int n; string clr[7]; string cm = "";
  srand(time(NULL));
  thecube.ResetCube();
  col[1] = "FFFFFF"; col[2] = "FF8000"; col[3] = "0000FF";
  col[4] = "FF0000"; col[5] = "00FF00"; col[6] = "FFFF00";
  if (cmdc >= 2) cm = cmd;
  while (cm.length() > 0) {
    if (cm.substr(0, 9) == "!scramble") {
      cm = cm.substr(9, cm.length() - 9);
      thecube.ScrambleCube();
      thetocube.ScrambleCube();
    } else if (cm.substr(0, 9) == "!scrambl1") {
      cm = cm.substr(9, cm.length() - 9);
      thecube.ScrambleCube();
    } else if (cm.substr(0, 9) == "!scrambl2") {
      cm = cm.substr(9, cm.length() - 9);
      thetocube.ScrambleCube();
    } else if (cm.substr(0, 6) == "!cube-" && cm.length() >= 60) {
      cm = cm.substr(6, cm.length() - 6);
      for (int i = -1; i <= 1; i++) {
        for (int j = -1; j <= 1; j++) {
          *thecube.face(j, 2, -i) = cm.at(i*3+j+4)-48;
          *thecube.face(j, -i, -2) = cm.at(i*3+j+13)-48;
          *thecube.face(-2, -i, -j) = cm.at(i*3+j+22)-48;
          *thecube.face(-j, -i, 2) = cm.at(i*3+j+31)-48;
          *thecube.face(2, -i, j) = cm.at(i*3+j+40)-48;
          *thecube.face(j, -2, i) = cm.at(i*3+j+49)-48;
        }
      }
      cm = cm.substr(54, cm.length() - 54);
    } else if (cm.substr(0, 8) == "!tocube-" && cm.length() >= 62) {
      cm = cm.substr(8, cm.length() - 8);
      for (int i = -1; i <= 1; i++) {
        for (int j = -1; j <= 1; j++) {
          *thetocube.face(j, 2, -i) = cm.at(i*3+j+4)-48;
          *thetocube.face(j, -i, -2) = cm.at(i*3+j+13)-48;
          *thetocube.face(-2, -i, -j) = cm.at(i*3+j+22)-48;
          *thetocube.face(-j, -i, 2) = cm.at(i*3+j+31)-48;
          *thetocube.face(2, -i, j) = cm.at(i*3+j+40)-48;
          *thetocube.face(j, -2, i) = cm.at(i*3+j+49)-48;
        }
      }
      cm = cm.substr(54, cm.length() - 54);
    } else if (cm.substr(0, 9) == "!centers-" && cm.length() >= 15) {
      cm = cm.substr(9, cm.length() - 9);
      *thecube.face(0, 1, 0) = cm.at(0)-48;
      *thecube.face(0, 0, -1) = cm.at(1)-48;
      *thecube.face(-1, 0, 0) = cm.at(2)-48;
      *thecube.face(0, 0, 1) = cm.at(3)-48;
      *thecube.face(1, 0, 0) = cm.at(4)-48;
      *thecube.face(0, -1, 0) = cm.at(5)-48;
      cm = cm.substr(6, cm.length() - 6);
    } else if (cm.substr(0, 11) == "!tocenters-" && cm.length() >= 17) {
      cm = cm.substr(11, cm.length() - 11);
      *thetocube.face(0, 1, 0) = cm.at(0)-48;
      *thetocube.face(0, 0, -1) = cm.at(1)-48;
      *thetocube.face(-1, 0, 0) = cm.at(2)-48;
      *thetocube.face(0, 0, 1) = cm.at(3)-48;
      *thetocube.face(1, 0, 0) = cm.at(4)-48;
      *thetocube.face(0, -1, 0) = cm.at(5)-48;
      cm = cm.substr(6, cm.length() - 6);
    } else if (cm.substr(0, 8) == "!colors-" && cm.length() >= 44) {
      cm = cm.substr(8, cm.length() - 8);
      n = 1;
      for (int i = 1; i <= 6; i++) {
        clr[i] = "";
        for (int j = 0; j <= 5; j++) {
          if ((cm.at(j)-48 < 0 || cm.at(j)-48 > 9) &&
           (cm.at(j)-65 < 0 || cm.at(j)-65 > 6) &&
           (cm.at(j)-97 < 0 || cm.at(j)-97 > 6))
            n = 0;
          else clr[i] += cm.at(j);
        }
        cm = cm.substr(6, cm.length() - 6);
      }
      if (n == 1) {
        for (int i = 1; i <= 6; i++)
          col[i] = clr[i];
      }
    } else if (cm.substr(0, 13) == "!withdiagrams") {
      disp_diagrams = "1";
      cm = cm.substr(13, cm.length() - 13);
    } else if (cm.substr(0, 13) == "!withgraphics") {
      disp_graphics = "1";
      cm = cm.substr(13, cm.length() - 13);
    } else if (cm.substr(0, 7) == "!fixcen") {
      fixcen = "1";
      cm = cm.substr(7, cm.length() - 7);
    } else if (cm.substr(0, 8) == "!solveto") {
      solveto = "1";
      cm = cm.substr(8, cm.length() - 8);
    } else if (cm.substr(0, 7) == "!fixcol") {
      fixcol = "1";
      cm = cm.substr(7, cm.length() - 7);
    } else if (cm.substr(0, 4) == "!adv") {
      adv = "1";
      cm = cm.substr(4, cm.length() - 4);
    } else if (cm.substr(0, 5) == "!sel-" && cm.length() >= 6) {
      sel = cm.at(5);
      cm = cm.substr(6, cm.length() - 6);
    } else if (cm.substr(0, 5) == "!help") {
      help = "1";
      cm = cm.substr(5, cm.length() - 5);
    } else {
      cm = "";
    }
  }
}
// main function...
int main(int argc, char *argv[]) {
  cmdc = argc;
  if (cmdc >= 2) cmd = argv[1];
  char *mix = "cubexcgiin.htm", f[256]; int w; string s;
  CommandDefaults();
  printf("Content-Type: text/html\n\n");
  FILE *fp = fopen(mix, "r");
  if (fp != NULL) {
    while (fgets(f, sizeof(f), fp)) {
      s = f;
      if      ((w = s.find("%javadefaults%")) >= 0)
        JavaDefaults();
      else if ((w = s.find("%version%")) >= 0)
        printf("%s\n", Cubex::ver);
      else
        printf("%s", s.c_str());
    }
    fclose(fp);
  } else {
    printf("Missing %s template.  Please re-install.\n", mix);
  }
  return 0;
}
